Blame SOURCES/coreutils-i18n-un-expand-BOM.patch

d3767b
From 7a7c776a4e228d180e74614fd8c8afcad5d4bdf7 Mon Sep 17 00:00:00 2001
d3767b
From: Jakub Martisko <jamartis@redhat.com>
d3767b
Date: Thu, 7 Jul 2016 12:53:26 +0200
d3767b
Subject: [PATCH] coreutils-i18n-un-expand-BOM.patch
d3767b
d3767b
---
d3767b
 src/expand-common.c  | 114 +++++++++++++++++++++++++++++++++++++++++++++++++++
d3767b
 src/expand-common.h  |  12 ++++++
d3767b
 src/expand.c         |  45 +++++++++++++++++++-
d3767b
 src/unexpand.c       |  43 ++++++++++++++++++-
d3767b
 tests/expand/mb.sh   |  71 ++++++++++++++++++++++++++++++++
d3767b
 tests/unexpand/mb.sh |  59 ++++++++++++++++++++++++++
d3767b
 6 files changed, 342 insertions(+), 2 deletions(-)
d3767b
d3767b
diff --git a/src/expand-common.c b/src/expand-common.c
d3767b
index 4657e46..97cbb09 100644
d3767b
--- a/src/expand-common.c
d3767b
+++ b/src/expand-common.c
d3767b
@@ -19,6 +19,7 @@
d3767b
 #include <assert.h>
d3767b
 #include <stdio.h>
d3767b
 #include <sys/types.h>
d3767b
+#include <mbfile.h>
d3767b
 #include "system.h"
d3767b
 #include "die.h"
d3767b
 #include "error.h"
d3767b
@@ -126,6 +127,119 @@ set_increment_size (uintmax_t tabval)
d3767b
   return ok;
d3767b
 }
d3767b
 
d3767b
+extern int
d3767b
+set_utf_locale (void)
d3767b
+{
d3767b
+      /*try using some predefined locale */
d3767b
+      const char* predef_locales[] = {"C.UTF8","en_US.UTF8","en_GB.UTF8"};
d3767b
+
d3767b
+      const int predef_locales_count=3;
d3767b
+      for (int i=0;i
d3767b
+        {
d3767b
+          if (setlocale(LC_ALL,predef_locales[i])!=NULL)
d3767b
+          {
d3767b
+            break;
d3767b
+          }
d3767b
+          else if (i==predef_locales_count-1)
d3767b
+          {
d3767b
+            return 1;
d3767b
+            error (EXIT_FAILURE, errno, _("cannot set UTF-8 locale"));
d3767b
+          }
d3767b
+        }
d3767b
+        return 0;
d3767b
+}
d3767b
+
d3767b
+extern bool
d3767b
+check_utf_locale(void)
d3767b
+{
d3767b
+  char* locale = setlocale (LC_CTYPE , NULL);
d3767b
+  if (locale == NULL)
d3767b
+  {
d3767b
+    return false;
d3767b
+  }
d3767b
+  else if (strcasestr(locale, "utf8") == NULL && strcasestr(locale, "utf-8") == NULL)
d3767b
+  {
d3767b
+    return false;
d3767b
+  }
d3767b
+  return true;
d3767b
+}
d3767b
+
d3767b
+extern bool
d3767b
+check_bom(FILE* fp, mb_file_t *mbf)
d3767b
+{
d3767b
+  int c;
d3767b
+
d3767b
+
d3767b
+  c=fgetc(fp);
d3767b
+
d3767b
+  /*test BOM header of the first file */
d3767b
+  mbf->bufcount=0;
d3767b
+  if (c == 0xEF)
d3767b
+  {
d3767b
+    c=fgetc(fp);
d3767b
+  }
d3767b
+  else
d3767b
+  {
d3767b
+    if (c != EOF)
d3767b
+    {
d3767b
+      ungetc(c,fp);
d3767b
+    }
d3767b
+    return false;
d3767b
+  }
d3767b
+
d3767b
+  if (c == 0xBB)
d3767b
+  {
d3767b
+    c=fgetc(fp);
d3767b
+  }
d3767b
+  else
d3767b
+  {
d3767b
+    if ( c!= EOF )
d3767b
+    {
d3767b
+      mbf->buf[0]=(unsigned char) 0xEF;
d3767b
+      mbf->bufcount=1;
d3767b
+      ungetc(c,fp);
d3767b
+      return false;
d3767b
+    }
d3767b
+    else
d3767b
+    {
d3767b
+      ungetc(0xEF,fp);
d3767b
+      return false;
d3767b
+    }
d3767b
+  }
d3767b
+  if (c == 0xBF)
d3767b
+  {
d3767b
+    mbf->bufcount=0;
d3767b
+    return true;
d3767b
+  }
d3767b
+  else
d3767b
+  {
d3767b
+    if (c != EOF)
d3767b
+    {
d3767b
+      mbf->buf[0]=(unsigned char) 0xEF;
d3767b
+      mbf->buf[1]=(unsigned char) 0xBB;
d3767b
+      mbf->bufcount=2;
d3767b
+      ungetc(c,fp);
d3767b
+      return false;
d3767b
+    }
d3767b
+    else
d3767b
+    {
d3767b
+      mbf->buf[0]=(unsigned char) 0xEF;
d3767b
+      mbf->bufcount=1;
d3767b
+      ungetc(0xBB,fp);
d3767b
+      return false;
d3767b
+    }
d3767b
+  }
d3767b
+  return false;
d3767b
+}
d3767b
+
d3767b
+extern void
d3767b
+print_bom(void)
d3767b
+{
d3767b
+  putc (0xEF, stdout);
d3767b
+  putc (0xBB, stdout);
d3767b
+  putc (0xBF, stdout);
d3767b
+}
d3767b
+
d3767b
 /* Add the comma or blank separated list of tab stops STOPS
d3767b
    to the list of tab stops.  */
d3767b
 extern void
d3767b
diff --git a/src/expand-common.h b/src/expand-common.h
d3767b
index 8cb2079..763bfda 100644
d3767b
--- a/src/expand-common.h
d3767b
+++ b/src/expand-common.h
d3767b
@@ -34,6 +34,18 @@ extern size_t max_column_width;
d3767b
 /* The desired exit status.  */
d3767b
 extern int exit_status;
d3767b
 
d3767b
+extern int
d3767b
+set_utf_locale (void);
d3767b
+
d3767b
+extern bool
d3767b
+check_utf_locale(void);
d3767b
+
d3767b
+extern bool
d3767b
+check_bom(FILE* fp, mb_file_t *mbf);
d3767b
+
d3767b
+extern void
d3767b
+print_bom(void);
d3767b
+
d3767b
 /* Add tab stop TABVAL to the end of 'tab_list'.  */
d3767b
 extern void
d3767b
 add_tab_stop (uintmax_t tabval);
d3767b
diff --git a/src/expand.c b/src/expand.c
d3767b
index 310b349..4136824 100644
d3767b
--- a/src/expand.c
d3767b
+++ b/src/expand.c
d3767b
@@ -103,11 +103,33 @@ expand (void)
d3767b
   FILE *fp = next_file (NULL);
d3767b
   mb_file_t mbf;
d3767b
   mbf_char_t c;
d3767b
+  /* True if the starting locale is utf8.  */
d3767b
+  bool using_utf_locale;
d3767b
+
d3767b
+  /* True if the first file contains BOM header.  */
d3767b
+  bool found_bom;
d3767b
+  using_utf_locale=check_utf_locale();
d3767b
 
d3767b
   if (!fp)
d3767b
     return;
d3767b
-
d3767b
   mbf_init (mbf, fp);
d3767b
+  found_bom=check_bom(fp,&mbf);
d3767b
+
d3767b
+  if (using_utf_locale == false && found_bom == true)
d3767b
+  {
d3767b
+    /*try using some predefined locale */
d3767b
+
d3767b
+    if (set_utf_locale () != 0)
d3767b
+    {
d3767b
+      error (EXIT_FAILURE, errno, _("cannot set UTF-8 locale"));
d3767b
+    }
d3767b
+  }
d3767b
+
d3767b
+
d3767b
+  if (found_bom == true)
d3767b
+  {
d3767b
+    print_bom();
d3767b
+  }
d3767b
 
d3767b
   while (true)
d3767b
     {
d3767b
@@ -132,6 +154,27 @@ expand (void)
d3767b
             if ((mb_iseof (c)) && (fp = next_file (fp)))
d3767b
               {
d3767b
                 mbf_init (mbf, fp);
d3767b
+                if (fp!=NULL)
d3767b
+                {
d3767b
+                  if (check_bom(fp,&mbf)==true)
d3767b
+                  {
d3767b
+                    /*Not the first file - check BOM header*/
d3767b
+                    if (using_utf_locale==false && found_bom==false)
d3767b
+                    {
d3767b
+                      /*BOM header in subsequent file but not in the first one. */
d3767b
+                      error (EXIT_FAILURE, errno, _("combination of files with and without BOM header"));
d3767b
+                    }
d3767b
+                  }
d3767b
+                  else
d3767b
+                  {
d3767b
+                    if(using_utf_locale==false && found_bom==true)
d3767b
+                    {
d3767b
+                      /*First file conatined BOM header - locale was switched to UTF
d3767b
+                       *all subsequent files should contain BOM. */
d3767b
+                      error (EXIT_FAILURE, errno, _("combination of files with and without BOM header"));
d3767b
+                    }
d3767b
+                  }
d3767b
+                }
d3767b
                 continue;
d3767b
               }
d3767b
             else
d3767b
diff --git a/src/unexpand.c b/src/unexpand.c
d3767b
index 863a90a..5681b58 100644
d3767b
--- a/src/unexpand.c
d3767b
+++ b/src/unexpand.c
d3767b
@@ -116,16 +116,36 @@ unexpand (void)
d3767b
      include characters other than spaces, so the blanks must be
d3767b
      stored, not merely counted.  */
d3767b
   mbf_char_t *pending_blank;
d3767b
+  /* True if the starting locale is utf8.  */
d3767b
+  bool using_utf_locale;
d3767b
+
d3767b
+  /* True if the first file contains BOM header.  */
d3767b
+  bool found_bom;
d3767b
+  using_utf_locale=check_utf_locale();
d3767b
 
d3767b
   if (!fp)
d3767b
     return;
d3767b
+  mbf_init (mbf, fp);
d3767b
+  found_bom=check_bom(fp,&mbf);
d3767b
+
d3767b
+  if (using_utf_locale == false && found_bom == true)
d3767b
+  {
d3767b
+    /*try using some predefined locale */
d3767b
 
d3767b
+    if (set_utf_locale () != 0)
d3767b
+    {
d3767b
+      error (EXIT_FAILURE, errno, _("cannot set UTF-8 locale"));
d3767b
+    }
d3767b
+  }
d3767b
   /* The worst case is a non-blank character, then one blank, then a
d3767b
      tab stop, then MAX_COLUMN_WIDTH - 1 blanks, then a non-blank; so
d3767b
      allocate MAX_COLUMN_WIDTH bytes to store the blanks.  */
d3767b
   pending_blank = xmalloc (max_column_width * sizeof (mbf_char_t));
d3767b
 
d3767b
-  mbf_init (mbf, fp);
d3767b
+  if (found_bom == true)
d3767b
+  {
d3767b
+    print_bom();
d3767b
+  }
d3767b
 
d3767b
   while (true)
d3767b
     {
d3767b
@@ -169,6 +189,27 @@ unexpand (void)
d3767b
             if ((mb_iseof (c)) && (fp = next_file (fp)))
d3767b
               {
d3767b
                 mbf_init (mbf, fp);
d3767b
+                if (fp!=NULL)
d3767b
+                {
d3767b
+                  if (check_bom(fp,&mbf)==true)
d3767b
+                  {
d3767b
+                    /*Not the first file - check BOM header*/
d3767b
+                    if (using_utf_locale==false && found_bom==false)
d3767b
+                    {
d3767b
+                      /*BOM header in subsequent file but not in the first one. */
d3767b
+                      error (EXIT_FAILURE, errno, _("combination of files with and without BOM header"));
d3767b
+                    }
d3767b
+                  }
d3767b
+                  else
d3767b
+                  {
d3767b
+                    if(using_utf_locale==false && found_bom==true)
d3767b
+                    {
d3767b
+                      /*First file conatined BOM header - locale was switched to UTF
d3767b
+                       *all subsequent files should contain BOM. */
d3767b
+                      error (EXIT_FAILURE, errno, _("combination of files with and without BOM header"));
d3767b
+                    }
d3767b
+                  }
d3767b
+                }
d3767b
                 continue;
d3767b
               }
d3767b
             else
d3767b
diff --git a/tests/expand/mb.sh b/tests/expand/mb.sh
d3767b
index 031be7a..1621c84 100755
d3767b
--- a/tests/expand/mb.sh
d3767b
+++ b/tests/expand/mb.sh
d3767b
@@ -109,4 +109,75 @@ env printf '12345678
d3767b
 expand < in > out || fail=1
d3767b
 compare exp out > /dev/null 2>&1 || fail=1
d3767b
 
d3767b
+
d3767b
+
d3767b
+#BOM header test 1
d3767b
+printf "\xEF\xBB\xBF" > in; cat <<\EOF >> in || framework_failure_
d3767b
+1234567812345678123456781
d3767b
+.       .       .       .
d3767b
+a	b	c	d
d3767b
+.       .       .       .
d3767b
+ä	ö	ü	ß
d3767b
+.       .       .       .
d3767b
+EOF
d3767b
+env printf '   äöü\t.    öüä.   \tä xx\n' >> in || framework_failure_
d3767b
+
d3767b
+printf "\xEF\xBB\xBF" > exp; cat <<\EOF >> exp || framework_failure_
d3767b
+1234567812345678123456781
d3767b
+.       .       .       .
d3767b
+a       b       c       d
d3767b
+.       .       .       .
d3767b
+ä       ö       ü       ß
d3767b
+.       .       .       .
d3767b
+   äöü  .    öüä.       ä xx
d3767b
+EOF
d3767b
+
d3767b
+
d3767b
+expand < in > out || fail=1
d3767b
+compare exp out > /dev/null 2>&1 || fail=1
d3767b
+
d3767b
+LANG=C expand < in > out || fail=1
d3767b
+compare exp out > /dev/null 2>&1 || fail=1
d3767b
+
d3767b
+LC_ALL=C expand < in > out || fail=1
d3767b
+compare exp out > /dev/null 2>&1 || fail=1
d3767b
+
d3767b
+
d3767b
+printf '\xEF\xBB\xBF' > in1; cat <<\EOF >> in1 || framework_failure_
d3767b
+1234567812345678123456781
d3767b
+.       .       .       .
d3767b
+a	b	c	d
d3767b
+.       .       .       .
d3767b
+ä	ö	ü	ß
d3767b
+.       .       .       .
d3767b
+EOF
d3767b
+env printf '   äöü\t.    öüä.   \tä xx\n' >> in1 || framework_failure_
d3767b
+
d3767b
+
d3767b
+printf '\xEF\xBB\xBF' > exp; cat <<\EOF >> exp || framework_failure_
d3767b
+1234567812345678123456781
d3767b
+.       .       .       .
d3767b
+a       b       c       d
d3767b
+.       .       .       .
d3767b
+ä       ö       ü       ß
d3767b
+.       .       .       .
d3767b
+   äöü  .    öüä.       ä xx
d3767b
+1234567812345678123456781
d3767b
+.       .       .       .
d3767b
+a       b       c       d
d3767b
+.       .       .       .
d3767b
+ä       ö       ü       ß
d3767b
+.       .       .       .
d3767b
+   äöü  .    öüä.       ä xx
d3767b
+EOF
d3767b
+
d3767b
+expand in1 in1 > out || fail=1
d3767b
+compare exp out > /dev/null 2>&1 || fail=1
d3767b
+
d3767b
+LANG=C expand in1 in1  > out || fail=1
d3767b
+compare exp out > /dev/null 2>&1 || fail=1
d3767b
+
d3767b
+LC_ALL=C expand in1 in1 > out || fail=1
d3767b
+compare exp out > /dev/null 2>&1 || fail=1
d3767b
+
d3767b
 exit $fail
d3767b
diff --git a/tests/unexpand/mb.sh b/tests/unexpand/mb.sh
d3767b
index 8d75652..9d4ee3e 100755
d3767b
--- a/tests/unexpand/mb.sh
d3767b
+++ b/tests/unexpand/mb.sh
d3767b
@@ -111,3 +111,62 @@ env printf '12345678
d3767b
 
d3767b
 unexpand -a < in > out || fail=1
d3767b
 compare exp out > /dev/null 2>&1 || fail=1
d3767b
+
d3767b
+#BOM header test 1
d3767b
+printf "\xEF\xBB\xBF" > in; cat <<\EOF >> in || framework_failure_
d3767b
+1234567812345678123456781
d3767b
+.       .       .       .
d3767b
+a       b       c       d
d3767b
+.       .       .       .
d3767b
+ä       ö       ü       ß
d3767b
+.       .       .       .
d3767b
+   äöü  .    öüä.       ä xx
d3767b
+EOF
d3767b
+env printf '   äöü\t.    öüä.   \tä xx\n' >> in || framework_failure_
d3767b
+
d3767b
+printf "\xEF\xBB\xBF" > exp; cat <<\EOF >> exp || framework_failure_
d3767b
+1234567812345678123456781
d3767b
+.	.	.	.
d3767b
+a	b	c	d
d3767b
+.	.	.	.
d3767b
+ä	ö	ü	ß
d3767b
+.	.	.	.
d3767b
+   äöü	.    öüä.	ä xx
d3767b
+EOF
d3767b
+
d3767b
+unexpand < in > out || fail=1
d3767b
+compare exp out > /dev/null 2>&1 || fail=1
d3767b
+
d3767b
+LANG=C unexpand < in > out || fail=1
d3767b
+compare exp out > /dev/null 2>&1 || fail=1
d3767b
+
d3767b
+LC_ALL=C unexpand < in > out || fail=1
d3767b
+compare exp out > /dev/null 2>&1 || fail=1
d3767b
+
d3767b
+
d3767b
+printf "\xEF\xBB\xBF" > exp; cat <<\EOF >> exp || framework_failure_
d3767b
+1234567812345678123456781
d3767b
+.	.	.	.
d3767b
+a	b	c	d
d3767b
+.	.	.	.
d3767b
+ä	ö	ü	ß
d3767b
+.	.	.	.
d3767b
+   äöü	.    öüä.	ä xx
d3767b
+1234567812345678123456781
d3767b
+.	.	.	.
d3767b
+a	b	c	d
d3767b
+.	.	.	.
d3767b
+ä	ö	ü	ß
d3767b
+.	.	.	.
d3767b
+   äöü	.    öüä.	ä xx
d3767b
+EOF
d3767b
+
d3767b
+
d3767b
+unexpand in in > out || fail=1
d3767b
+compare exp out > /dev/null 2>&1 || fail=1
d3767b
+
d3767b
+LANG=C unexpand in in > out || fail=1
d3767b
+compare exp out > /dev/null 2>&1 || fail=1
d3767b
+
d3767b
+LC_ALL=C unexpand in in > out || fail=1
d3767b
+compare exp out > /dev/null 2>&1 || fail=1
d3767b
-- 
d3767b
2.9.3
d3767b